import * as hast from 'hast';
import { IThemedToken, Highlighter, Lang, Theme } from 'shiki';

/**
 * @see https://github.com/shikijs/shiki/blob/main/packages/shiki/src/types.ts#L171-L176
 */
declare type StringLiteralUnion<T extends U, U = string> = T | (U & {});
declare type LineOption = {
    line: number;
    classes?: string[];
};
declare type HastRendererOptions = {
    langId?: string;
    fg?: string;
    bg?: string;
    lineOptions?: LineOption[];
};
declare const renderToHast: (lines: IThemedToken[][], options?: HastRendererOptions) => hast.Element;
declare const codeToHast: (highlighter: Highlighter, code: string, lang?: StringLiteralUnion<Lang> | undefined, theme?: StringLiteralUnion<Theme, string> | undefined, options?: HastRendererOptions | undefined) => hast.Element;

export { HastRendererOptions, codeToHast, renderToHast };
